<?php
class printdiff
{
	var $diff="";
	var $output="";
	var $sections=0;
	
	var $blankcolor = "#FFFFFF";
	var $oldcolor = "#FFCC00";
	var $newcolor = "#6699CC";
	var $deletecolor = "#FF6633";
	var $insertcolor = "#66CC00";
		
	function printdiff($diff)
	{
		$this->output="";
		$this->diff=$diff;	
	}
	
	
	
	function output($usediff=0)
	{
		$this->output="";
		$this->unified_diff($usediff);
		return array("patch"=>$this->output, "sections"=>$this->sections);
	}


	function unified_diff($usediff=0)
	{
		$lines=explode("\n",trim($this->diff));
		// first remove the first two lines
		unset($lines[0]);
		unset($lines[1]);
		
		
		// only necessary if patch was generated by `diff'
		if($usediff==1)
		{
			$newlines=array();
			foreach($lines as $lineno=>$line)
			{
				$op=substr($line,0,1);
				if(trim(substr($line,1))) $newlines[]=$line;
			}
			$lines=$newlines;
		}
		
		// leave inserts & removes ...
		// mark changes with < and > (old and new lines)
		// to find all "edged" of removes, get all lines with 
		// + operator
		$removes = preg_grep("/^(\-)/", $lines);
		if($removes)
		{
			$edges=array();
			$lastno=null;
			unset($start);
			// find "edges" of each remove ...
			foreach($removes as $lineno=>$line)
			{
				// edge found
				if(intval($lastno)+1!=$lineno)
				{
					// end ?
					if(isset($start))
					{
						// prepend start range
						$edges[]="$start-$lastno";
						unset($start);
					}
					// or start ??
					$start=$lineno;	
				}
				$lastno=$lineno;
			}
			// add last lineno, which was not added by the loop
			$edges[]=$start."-".$lineno;
			$removes=$edges;
			unset($edges);
		}


		// almost the same for inserts
		$inserts = preg_grep("/^(\+)/", $lines);
		if($inserts)
		{
			$edges=array();
			$lastno=null;
			unset($start);
			// find "edges" of each remove ...
			foreach($inserts as $lineno=>$line)
			{
				// edge found
				if(intval($lastno)+1!=$lineno)
				{
					// end ?
					if(isset($start))
					{
						// prepend start range
						$edges[]="$start-$lastno";
						unset($start);
					}
					// or start ??
					$start=$lineno;	
				}
				$lastno=$lineno;
			}
			// add last lineno, which was not added by the loop
			$edges[]=$start."-".$lineno;
			$inserts=$edges;
			unset($edges);
		}

		
		// we have the range of all inserts and removes.
		// now we must find all removes which are directly
		// followed by a insert..
		$changes=array();
		foreach($removes as $range)
		{
			list(,$start)=explode("-",$range);
			$start++;
			// find inserts which follow this range
			$insert=preg_grep("/^$start\-[0-9]+$/",$inserts);
			if(count($insert)==1)
			{
				$changes[]=array("removes"=>$range, "inserts"=>current($insert));
			}
		}
		unset($removes);
		unset($inserts);
		
		
		// now go on and change the operator for these changes
		foreach($changes as $hunk)
		{
			list($start,$end)=explode("-",$hunk['removes']);
			for($start;$start<=$end;$start++) $lines[$start][0]="<";
			list($start,$end)=explode("-",$hunk['inserts']);
			for($start;$start<=$end;$start++) $lines[$start][0]=">";
		}
		
		global $tpl, $language;
		$patch="";
		$lastop="";
		foreach($lines as $lineno=>$line)
		{
			$op=trim(substr($line,0,1));
			
			// start of hunk
			if($op=="@")
			{
				// parse old hunk
				if($patch) eval("\$this->output .= \"".$tpl->get("compare_hunk")."\";");
				preg_match("/^@@ \-([0-9]+),([0-9]+) \+([0-9]+),([0-9]+) @@$/", $line, $range);
				$op="";
				$patch="";
			}
			else
			{
				$line=substr($line,1);
				if(!$op) $bgcolor='';
				elseif($op=='-') $bgcolor=$this->deletecolor;
				elseif($op=='+') $bgcolor=$this->insertcolor;
				elseif($op=='<') $bgcolor=$this->oldcolor;
				elseif($op=='>') $bgcolor=$this->newcolor;
				$patch.=($bgcolor ? '<span style=\'background-color: '.$bgcolor.';\'>' : '').htmlentities($line).($bgcolor ? '</span>' : '')."\n";
			}
			if(!$lastop && $op) $this->sections++;
			$lastop=$op;
		}
		// parse last hunk
		eval("\$this->output .= \"".$tpl->get("compare_hunk")."\";");
	}
	
	
	
	function context_diff($usediff)
	{
		$this->output=$this->diff;	
	}
}
?>