<?php
require("functions.php");
require("db_connection.php");
require("class.tpl.php");
require("class.session.php");

// edit/parse incoming data. 
//
// - fill the new superglobals if not available (phpversion <4.10)
// - disable magic_quotes_runtime
// - stripslashes from cookies, get and post if magic_quotes_gpc is enabled
//
$phpversion=(int)(str_replace(".","",phpversion()));
if($phpversion<410)
{
	$_REQUEST=array();
	$_COOKIE=array();
	$_POST=array();
	$_GET=array();
	$_SERVER=array();
	$_FILES=array();
	$_ENV=array();
	$_SESSION=array();
	get_vars_old();
}
if (get_magic_quotes_gpc()) {
  if(is_array($_REQUEST)) $_REQUEST=stripslashes_array($_REQUEST);
  if(is_array($_POST)) $_POST=stripslashes_array($_POST);
  if(is_array($_GET)) $_GET=stripslashes_array($_GET);
  if(is_array($_COOKIE)) $_COOKIE=stripslashes_array($_COOKIE);
}
@set_magic_quotes_runtime(0);


// start session
$session=new session();
$sid=$session->sid();
$sidviaget=$sid;
register_shutdown_function("session_store");


// if possible (zlib library loaded) compress the output
if(extension_loaded("zlib") && ($phpversion >= 404) && strstr($_SERVER["HTTP_ACCEPT_ENCODING"],"'gzip"))
{
	ob_start("ob_gzhandler");
}


// get filename of the requested file
// uses PHP_SELF instead SCRIPT_FILENAME like in previous version
#$self_name = basename($_SERVER['SCRIPT_FILENAME']);
#$self_name = basename($_SERVER['SCRIPT_NAME']);
$self_name = basename($_SERVER['PHP_SELF']);



// initiate template handler
$tpl = new tpl("templates","tpl");
$tpls  = array();




// read options
$options=array();
$result=$db->query("SELECT varname,value FROM ".$db->getPrefix()."options");
while($row=$db->fetch_array($result)) $options[$row['varname']]=$row['value'];







// entity authentification (every request)
// verify session
// the user id is stored in the session
if($self_name != "login.php" && $self_name != "logout.php")
{
	$user_info = array();
	$writeaccess = array();
	$readaccess = array();

	if($session->is_registered("s_user_id")) $s_user_id = $session->get("s_user_id");
	else $s_user_id=0;
	
	if($s_user_id) $user_info = $db->query_first("SELECT * FROM ".$db->getPrefix()."user WHERE user_id='".$s_user_id."'");

	if(isset($user_info['user_id']) && $user_info['user_id'])
	{
		$new_time = $user_info['lastactivity'];
		$old_time = $user_info['lastvisit'];
		//if($old_time < (time()-1800))
		if($new_time < (time()-1800))
		{
	    		$old_time = $new_time;
	     		$new_time = time();
	        	$db->unbuffered_query("UPDATE ".$db->getPrefix()."user SET lastvisit = lastactivity, lastactivity = '$new_time' WHERE user_id = $user_info[user_id]",1);
		}
	    	else
		{
		    	$new_time = time();
	        	$db->unbuffered_query("UPDATE ".$db->getPrefix()."user SET lastactivity = '$new_time' WHERE user_id = $user_info[user_id]",1);
	    	}
		$user_info['lastactivity'] = $new_time;
		$user_info['lastvisit'] = $old_time;

		$access_result = $db->query("SELECT * FROM ".$db->getPrefix()."access WHERE user_id=$user_info[user_id]");
		while($row=$db->fetch_array($access_result))
		{
			$writeaccess[$row['project_id']]=$row['writeaccess'];
			$readaccess[$row['project_id']]=$row['readaccess'];
		}
		$db->free_result($access_result);
	}
	else
	{
		$user_info=array();
		$user_info['user_id']=0;
		$writeaccess=array();
		$readaccess=array();
		$session->unregister("s_user_id");
	}
}
else
{
		$user_info=array();
		$user_info['user_id']=0;
		$writeaccess=array();
		$readaccess=array();
}


// get language setting
// default language (defined in config.php in $config['lang'])
// can be overridden by a GET/SESSION value.
if(isset($user_info['lang_id']) && $user_info['lang_id']) $lang_id=$user_info['lang_id'];
elseif($session->is_registered("lang_id")) $lang_id=$session->get("lang_id");
if(isset($_REQUEST['lang_id'])) $lang_id=intval($_REQUEST['lang_id']);
if(isset($lang_id)) $r_lang=$db->query_first("SELECT lang_id FROM ".$db->getPrefix()."lang WHERE lang_id='".intval($lang_id)."'");
elseif(isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) && $_SERVER['HTTP_ACCEPT_LANGUAGE']) $r_lang=$db->query_first("SELECT lang_id FROM ".$db->getPrefix()."lang WHERE lang_code='".addslashes($_SERVER['HTTP_ACCEPT_LANGUAGE'])."'");
if(!isset($r_lang) || !$r_lang['lang_id']) $r_lang=$db->query_first("SELECT lang_id FROM ".$db->getPrefix()."lang WHERE lang_isdefault=1");
$lang_id=$r_lang['lang_id'];

if(isset($user_info['user_id']) && $user_info['user_id']) $db->unbuffered_query("UPDATE ".$db->getPrefix()."user SET lang_id=$lang_id WHERE user_id='$user_info[user_id]'",1);
elseif($session->get("lang_id")!=$lang_id) $session->register("lang_id",$lang_id);


// include selected languagefile
include("./lang/".$lang_id.".php");






// die and show a warning if the setup file still exists
if(file_exists("./install.php")) show_error("install_delete");




// show login form
if(!$user_info['user_id'] && $self_name != "login.php" && $self_name != "logout.php" && $self_name != "index.php")
{
	$authentificationcode=md5(uniqid(rand()));
	$session->register("authentificationcode",$authentificationcode);
	show_error("login");
}




// set and initiate parameters
if(isset($_REQUEST['project_id']))
{
	$project_id = intval($_REQUEST['project_id']);
}
else
{
	$project_id = 0;
}

if(isset($_REQUEST['file_id']))
{
	$file_id = intval($_REQUEST['file_id']);
}
else
{
	$file_id = 0;
}

if(isset($_REQUEST['version_id']))
{
	$version_id = intval($_REQUEST['version_id']);
}
else
{
	$version_id = 0;
}

if(isset($_REQUEST['dir']))
{
	$dir = $_REQUEST['dir'];
}
else
{
	$dir = "";
}






// avoid caching of the website
send_no_cache_header();


// verify parameters
if($version_id)
{
	$version_info = $db->query_first("SELECT project_id,file_id,version_id FROM ".$db->getPrefix()."versions WHERE version_id='$version_id'");
	//if(!$version_info['version_id']) show_error("input_error");
	if(!$version_info['version_id']) unset($version_id);
	else
	{	
		if($file_id && $version_info['file_id']!=$file_id) show_error("input_error");
		if($project_id && $version_info['project_id']!=$project_id) show_error("input_error");
		$file_id=$version_info['file_id'];
		$project_id=$version_info['project_id'];
	}
}
if($file_id)
{
	$file_info = $db->query_first("SELECT project_id,file_id FROM ".$db->getPrefix()."files WHERE file_id='$file_id'");
	if(!$file_info['file_id']) show_error("input_error");
	if($project_id && $file_info['project_id']!=$project_id) show_error("input_error");
	$project_id=$file_info['project_id'];
}
if($project_id)
{
	if(!isset($readaccess[$project_id]) || $readaccess[$project_id]==0) show_error("access_denied");
	$project_info = $db->query_first("SELECT * FROM ".$db->getPrefix()."projects WHERE project_id=$project_id", MYSQL_ASSOC);
	if(!$project_info['project_id']) show_error("input_error");
	if($project_info['writelock'] && $self_name!="unlockproject.php") show_error("writelock");
}



// identify user agent
if (ereg('Opera(/| )([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'], $log_version))
{
	define('USR_BROWSER_VER', $log_version[2]);
	define('USR_BROWSER_AGENT', 'OPERA');
}
elseif(ereg('MSIE ([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'], $log_version))
{
	define('USR_BROWSER_VER', $log_version[1]);
	define('USR_BROWSER_AGENT', 'IE');
}
elseif(ereg('OmniWeb/([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'], $log_version))
{
	define('USR_BROWSER_VER', $log_version[1]);
	define('USR_BROWSER_AGENT', 'OMNIWEB');
}
elseif(ereg('Mozilla/([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'], $log_version))
{
	define('USR_BROWSER_VER', $log_version[1]);
	define('USR_BROWSER_AGENT', 'MOZILLA');
}
elseif(ereg('Konqueror/([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'], $log_version))
{
	define('USR_BROWSER_VER', $log_version[1]);
	define('USR_BROWSER_AGENT', 'KONQUEROR');
}
else
{
	define('PMA_USR_BROWSER_VER', 0);
	define('PMA_USR_BROWSER_AGENT', 'OTHER');
}
?>