<?php
require("global.php");

// set a time limit because archive operations may last longer than normal operations
@set_time_limit(0);

// initiate parameters
if(isset($_REQUEST['time'])) $time = $_REQUEST['time'];
else $time = "";
if(isset($_REQUEST['action'])) $action = $_REQUEST['action'];
else $action = "";
if(isset($_REQUEST['snapshot_id'])) $snapshot_id = intval($_REQUEST['snapshot_id']);
else $snapshot_id = 0;
if(isset($_REQUEST['compression_level'])) $compression_level = intval($_REQUEST['compression_level']);
else $compression_level = -1;
if(isset($_REQUEST['archive_type'])) $archive_type = $_REQUEST['archive_type'];
else $archive_type="tgz";
if(isset($_REQUEST['comment'])) $comment = $_REQUEST['comment'];
else $comment = "";

if($compression_level>9 || $compression_level<-1) $compression_level=-1;
if($archive_type!="tgz" && $archive_type!="zip") $archive_type="zip";

/* keine Eingabe */
if(!$project_id)
{
	show_error("input_error");
}










/* bersicht der Snapshots */
if($action=="overview")
{
	eval("\$tpls['header'] = \"".$tpl->get("header")."\";");
	eval("\$tpls['footer'] = \"".$tpl->get("footer")."\";");

	$project_info['project_name']=htmlconverter($project_info['project_name']);
	$snapshots = $db->query("SELECT * FROM ".$db->getPrefix()."snapshots WHERE project_id=$project_id ORDER BY timestamp DESC");
	$tpls['snapshotbits'] = "";
	$tpls['snapshots'] = "";
	while($row = $db->fetch_array($snapshots))
	{
		$row['createdate_f'] = ifelse(date("dmY",time())==date("dmY",$row['createdate']),"<b>Heute</b>",date("d.m.Y",$row['createdate']))." - ".date("H:i",$row['createdate']);
		$row['timestamp_f'] = ifelse(date("dmY",time())==date("dmY",$row['timestamp']),"<b>Heute</b>",date("d.m.Y",$row['timestamp']))." - ".date("H:i",$row['timestamp']);
		eval("\$tpls['snapshotbits'] .= \"".$tpl->get("snapshots_overview_bit")."\";");
	}
	if($tpls['snapshotbits'])
	{
		eval("\$tpls['snapshots'] .= \"".$tpl->get("snapshots_overview_snapshots")."\";");
	}

	/* Auswahllisten zum Datum */
	$jahr_auswahl = "";
	$tag_auswahl = "";
	$mon_auswahl = "";
	for($i=intval(date('Y',$project_info['createdate']));$i<=intval(date('Y',time()));$i++)
	{
		$jahr_auswahl .= "<option value='$i'".ifelse(($i==date('Y',time()))," selected").">$i</option>\n";
	}
	for($i=1;$i<=12;$i++)
	{
		$mon_auswahl .= "<option value='$i'".ifelse(($i==date('n',time()))," selected").">$i</option>\n";
	}
	for($i=1;$i<=31;$i++)
	{
		$tag_auswahl .= "<option value='$i'".ifelse(($i==date('j',time()))," selected").">$i</option>\n";
	}
	$std_auswahl = date("G",time());
	$min_auswahl = date("i",time());
	eval("\$tpl->out(\"".$tpl->get("snapshots_overview")."\");");
}





/* Snapshot erstellen. */
if($action=="createsnapshot")
{
	if(!$writeaccess[$project_id])
	{
		show_error("access_denied");
	}
	
	/* aktuellen Snapshot */
	if($time=="latest")
	{
		$timestamp = time();
		$snapshot_info = $db->query_first("SELECT * FROM ".$db->getPrefix()."snapshots WHERE project_id=$project_id ORDER BY timestamp DESC LIMIT 1");
		/* letzter Snapshot ist nicht aktuell => neuer Snapshot */
		if($project_info['lastchange']>=$snapshot_info['createdate'])
		{
			$snapshot_id = create_package($project_id,"snapshots",$timestamp,$comment,$compression_level,$archive_type);
		}
		/* letzten Snapshot benutzen. */
		else
		{
			$snapshot_id = $snapshot_info['snapshot_id'];
		}
	}

	/* Snapshot zu einem bestimmten Zeitpunkt */
	elseif($time=="custom")
	{
		$timestamp = mktime(intval($_REQUEST['std']),intval($_REQUEST['min']),0,intval($_REQUEST['mon']),intval($_REQUEST['tag']),intval($_REQUEST['jahr']));
		// eingegebenes Datum liegt in der Zukunft
		if($timestamp>=time() || $timestamp<=$project_info['createdate']) show_error("input_error");
		$snapshot_info = $db->query_first("SELECT * FROM ".$db->getPrefix()."snapshots WHERE project_id=$project_id AND timestamp=$timestamp");
		if($snapshot_info['snapshot_id'])
		{
			$snapshot_id=$snapshot_info['snapshot_id'];
		}
		else
		{
			$snapshot_id = create_package($project_id,"snapshots",$timestamp,$comment,$compression_level,$archive_type);
		}
	}

	/* weiterleiten zu den Details. */
	if($snapshot_id)
	{
		header("Location: snapshots.php?project_id=$project_id&action=details&snapshot_id=$snapshot_id&sid=$sidviaget");
	}
}


/* Details zu einem Snapshot */
if($action=="details")
{
	$project_info['project_name']=htmlconverter($project_info['project_name']);
	$snapshot_info = $db->query_first("SELECT * FROM ".$db->getPrefix()."snapshots WHERE snapshot_id=$snapshot_id");
	if(!$snapshot_info['snapshot_id']) show_error("input_error");
	if(!$readaccess[$snapshot_info['project_id']]) show_error("access_denied");
	$snapshot_info['createdate_f'] = ifelse(date("dmY",time())==date("dmY",$snapshot_info['createdate']),"<b>Heute</b>",date("d.m.Y",$snapshot_info['createdate']))." - ".date("H:i",$snapshot_info['createdate']);
	$snapshot_info['timestamp_f'] = ifelse(date("dmY",time())==date("dmY",$snapshot_info['timestamp']),"<b>Heute</b>",date("d.m.Y",$snapshot_info['timestamp']))." - ".date("H:i",$snapshot_info['timestamp']);
	$snapshot_info['filesize'] = number_format(($snapshot_info['size']/1024),3,",",".");
	$snapshot_info['comment'] = nl2br(htmlconverter($snapshot_info['comment']));


	eval("\$tpls['header'] = \"".$tpl->get("header")."\";");
	eval("\$tpls['footer'] = \"".$tpl->get("footer")."\";");
	eval("\$tpl->out(\"".$tpl->get("snapshots_details")."\");");
}


/* Snapshot herunterladen */
if($action=="download")
{
	$snapshot_info = $db->query_first("SELECT * FROM ".$db->getPrefix()."snapshots WHERE snapshot_id='$snapshot_id'");
	if(!$snapshot_info['snapshot_id'])
	{
		show_error("input_error");
	}
	else $project_id=$snapshot_info['project_id'];
	if(!$readaccess[$project_id])
	{
		show_error("access_denied");
	}
	$compression_level = $snapshot_info['compression_level'];
	$archive_type = $snapshot_info['archive_type'];
	if($compression_level==-1 && $archive_type=="tgz") $extension="tar";
	elseif($compression_level>=0 && $archive_type=="tgz") $extension="tar.gz";
	elseif($archive_type="zip") $extension="zip";

	$filename = preg_replace("/[<>\|\?\.\*\/\\\]+/","_",$project_info['project_name'])."-".date("Y-m-d_H-i",$snapshot_info['timestamp'])."-".$snapshot_id.".".$extension;
	$mime_type = (USR_BROWSER_AGENT=="IE" || USR_BROWSER_AGENT=="OPERA") ? "application/octetstream" : "application/octet-stream";
	header("Content-Type: ".$mime_type);
	header("Expires: ".gmdate("D, d M Y H:i:s"));
	if(USR_BROWSER_AGENT=="IE")
	{
		header("Content-Disposition: inline; filename=\"".$filename."\"");
        	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
        	header("Pragma: public");
	}
	else
	{
		header("Content-Disposition: attachment; filename=\"".$filename."\"");
		header("Pragma: no-cache");
	}
	readfile("snapshots/$snapshot_id.$extension");

}


/** Snapshot lschen */
if($action=="delete")
{
	eval("\$tpls['header'] = \"".$tpl->get("header")."\";");
	eval("\$tpls['footer'] = \"".$tpl->get("footer")."\";");

	$snapshot_info = $db->query_first("SELECT * FROM ".$db->getPrefix()."snapshots WHERE snapshot_id='$snapshot_id'");
	if(!$snapshot_info['snapshot_id'])
	{
		show_error("input_error");
	}
	else $project_id=$snapshot_info['project_id'];
	if(!$readaccess[$project_id] || !$writeaccess[$project_id])
	{
		show_error("access_denied");
	}
	
	$db->query("DELETE FROM ".$db->getPrefix()."snapshots WHERE snapshot_id='$snapshot_id'");
	@unlink("./snapshots/".$snapshot_info['snapshot_id'].".".ifelse($snapshot_info['archive_type']=="zip","zip",ifelse($snapshot_info['archive_type']=="tgz" && $snapshot_info['compression_level']==-1,"tar",ifelse($snapshot_info['archive_type']=="tgz" && $snapshot_info['compression_level']>=0,"tar.gz"))));
	
	show_msg("done",-2);
}
?>